Class for creating Root PPS's for OLE containers

author | Xavier Noguer
category | PHPExcel
package | PHPExcel_Shared_OLE

### Methods

## Returns the amount of data saved for this PPS

    _DataLen() : integer

Inherited

access | public
inherited_from | \PHPExcel_Shared_OLE_PPS::_DataLen()

### Returns

`integer`The amount of data (in bytes)

## The constructor

    __construct(integer $time_1st, integer $time_2nd, $raChild)

### Parameters

#### $time_1st

`integer`

A timestamp

#### $time_2nd

`integer`

A timestamp

#### $raChild

## Calculate some numbers

    _calcSize(array $raList) : array

access | public

### Parameters

#### $raList

`array`

Reference to an array of PPS's

### Returns

`array`The array of numbers

## Returns a string with the PPS's WK (What is a WK?)

    _getPpsWk() : string

Inherited

access | public
inherited_from | \PHPExcel_Shared_OLE_PPS::_getPpsWk()

### Returns

`string`The binary string

## get small data (PPS's with data smaller than PHPExcel_Shared_OLE::OLE_DATA_SIZE_SMALL)

    _makeSmallData(array $raList)

access | public

### Parameters

#### $raList

`array`

&$raList Reference to array of PPS's

## Saving Big Block Depot

    _saveBbd(integer $iSbdSize, integer $iBsize, integer $iPpsCnt)

access | public

### Parameters

#### $iSbdSize

`integer`

#### $iBsize

`integer`

#### $iPpsCnt

`integer`

## Saving big data (PPS's with data bigger than PHPExcel_Shared_OLE::OLE_DATA_SIZE_SMALL)

    _saveBigData(integer $iStBlk, array $raList)

access | public

### Parameters

#### $iStBlk

`integer`

#### $raList

`array`

&$raList Reference to array of PPS's

## Save OLE header

    _saveHeader(integer $iSBDcnt, integer $iBBcnt, integer $iPPScnt)

access | public

### Parameters

#### $iSBDcnt

`integer`

#### $iBBcnt

`integer`

#### $iPPScnt

`integer`

## Saves all the PPS's WKs

    _savePps(array $raList)

access | public

### Parameters

#### $raList

`array`

Reference to an array with all PPS's

## Updates index and pointers to previous, next and children PPS's for this PPS.

    _savePpsSetPnt(array $raList, $to_save, $depth) : integer

InheritedStatic

I don't think it'll work with Dir PPS's.

access | public
inherited_from | \PHPExcel_Shared_OLE_PPS::_savePpsSetPnt()

### Parameters

#### $raList

`array`

&$raList Reference to the array of PPS's for the whole OLE container

#### $to_save

#### $depth

### Returns

`integer`The index for this PPS

## Method for saving the whole OLE container (including files).

    save(string | resource $filename) : mixed

In fact, if called with an empty argument (or '-'), it saves to a temporary file and then outputs it's contents to stdout. If a resource pointer to a stream created by fopen() is passed it will be used, but you have to close such stream by yourself.

access | public

### Parameters

#### $filename

`string` `resource`

The name of the file or stream where to save the OLE container.

### Returns

`mixed`true on success

## Helper function for caculating a magic value for block sizes

    _adjust2(integer $i2) : integer

Static

access | public
see | \save()

### Parameters

#### $i2

`integer`

The argument

### Returns

`integer`

### Properties

##

    $DirPps : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$DirPps

##

    $Name : string

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$Name

##

    $NextPps : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$NextPps

##

    $No : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$No

##

    $PrevPps : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$PrevPps

##

    $Size : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$Size

##

    $Time1st : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$Time1st

##

    $Time2nd : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$Time2nd

##

    $Type : integer

Inherited

Dir, Root or File

inherited_from | \PHPExcel_Shared_OLE_PPS::$$Type

##

    $_StartBlock : integer

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$_StartBlock

##

    $_data : string

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$_data

##

    $children : array

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$children

##

    $ole : \OLE

Inherited

inherited_from | \PHPExcel_Shared_OLE_PPS::$$ole

##

    $_tmp_dir : string